/**

*/
public class TestBinarySearchTree
{
   public static void main(String[] args)
   {
      BinarySearchTree<Integer> bst = new BinarySearchTree<>();
      bst.add(3);
      bst.add(5);
      bst.add(4);
      bst.add(2);
      bst.add(0);
      bst.add(1);
      bst.add(10);
      bst.add(7);
      System.out.println( bst.inOrder() + " ==>  " + bst );

      System.out.println("min = " + bst.min() );
      System.out.println("max = " + bst.max() );

      System.out.println("Searches.");
      System.out.println( bst.search(1) );
      System.out.println( bst.search(5) );
      System.out.println( bst.search(6) );

      System.out.println();

      System.out.println("Successors.");
      System.out.println( bst.successor(0) );
      System.out.println( bst.successor(1) );
      System.out.println( bst.successor(2) );
      System.out.println( bst.successor(3) );
      System.out.println( bst.successor(4) );
      System.out.println( bst.successor(5) );
      System.out.println( bst.successor(7) );
      //System.out.println( bst.successor(10) );

      System.out.println();

      System.out.println("Predecessors.");
      //System.out.println( bst.predecessor(0) );
      System.out.println( bst.predecessor(1) );
      System.out.println( bst.predecessor(2) );
      System.out.println( bst.predecessor(3) );
      System.out.println( bst.predecessor(4) );
      System.out.println( bst.predecessor(5) );
      System.out.println( bst.predecessor(7) );
      System.out.println( bst.predecessor(10) );

      System.out.println();

      System.out.println( bst.inOrder() + " ==>  " + bst );
      BinarySearchTree<Integer> bst2 = bst.removeP( 3 );  // Choose any element to remove.
      System.out.println( bst2.inOrder() + " ==>  " + bst2 );

      System.out.println();

      System.out.println( bst.inOrder() + " ==>  " + bst );
      while (0 != bst.size())
      {
         bst = bst.removeP(bst.max()); // Persistent remove method.
         System.out.println( bst.inOrder() + " ==>  " + bst );
         if (0 != bst.size())
         {
            bst = bst.removeP(bst.min());
            System.out.println( bst.inOrder() + " ==>  " + bst );
         }
      }
/*
      System.out.println( bst.inOrder() + " ==>  " + bst );
      while (0 != bst.size())
      {
         bst.remove(bst.max()); // Mutating remove method
         System.out.println( bst.inOrder() + " ==>  " + bst );
         if (0 != bst.size())
         {
            bst.remove(bst.min());
            System.out.println( bst.inOrder() + " ==>  " + bst );
         }
      }
*/
      System.out.println();

      // Create a degenerate BST that makes all operation O(n).
      BinarySearchTree<Integer> bst3 = new BinarySearchTree<>();
      bst3.add(0);
      bst3.add(1);
      bst3.add(2);
      bst3.add(3);
      bst3.add(4);
      bst3.add(5);
      bst3.add(7);
      bst3.add(10);
      System.out.println( bst3.inOrder() + " ==>  " + bst3 );
   }
}
